version: '3'

services:
  #--------------
  # Proxy
  #--------------
  proxy:
    image: nginx:alpine
    container_name: 'proxy'
    privileged: true
    volumes:
      - ./html:/usr/share/nginx/html
      - ./docker/proxy/conf.d/:/etc/nginx/conf.d
    ports:
      - ${PROXY_PORT}:80
    networks:
      - app-net

  #--------------
  # Frontend App
  #--------------
  frontend:
    container_name: app
    build: ./docker/frontend
    environment:
      - VIRTUAL_HOST=${APP_DOMAIN}
      #- VIRTUAL_PORT=${FRONT_PORT}
    expose:
      - ${FRONT_PORT}
    privileged: true
    volumes:
      - "./docker/frontend:/var/www/app"
      - /var/www/app/node_modules
    stdin_open: true
    command: npm run serve
    tty: true
    networks:
      - app-net

  #--------------
  # Api
  #--------------
  api:
    container_name: api
    build: ./docker/api
    environment:
      - VIRTUAL_HOST=${API_DOMAIN}
      #- VIRTUAL_PORT=${API_PORT}
    expose:
      - ${API_PORT}
    privileged: true
    volumes:
      - "./docker/api:/var/www/localhost/htdocs"
#      - "./docker/api/docker/php/overrides.ini:/usr/local/etc/php/conf.d/overrides.ini"
#      - "./docker/api/docker/apache/httpd.conf/:/etc/apache2/httpd.conf"
#      - "./docker/api/docker/apache/conf.d/api.vhost.conf:/etc/apache2/conf.d/api.conf"
#      - "./docker/api/docker/apache/conf.d/mpm.conf:/etc/apache2/conf.d/mpm.conf"
#      - "./docker/api/docker/apache/conf.d/security.conf:/etc/apache2/conf.d/security.conf"
    stdin_open: true
    tty: true
    networks:
      - app-net
      - back-net

  #--------------
  # DB
  #--------------
  mysql:
    image: mysql:8.0.16
    container_name: db01
    volumes:
      - db-store:/var/lib/mysql
      - ./docker/mysql/logs:/var/log/mysql
      - ./docker/mysql/conf.d:/etc/mysql/conf.d
    environment:
      - MYSQL_DATABASE=${DB_NAME}
      - MYSQL_USER=${DB_USER}
      - MYSQL_PASSWORD=${DB_PASS}
      - MYSQL_ROOT_PASSWORD=${DB_PASS}
      - TZ=${TZ}
      - DB_PORT=${DB_PORT}
    networks:
      - back-net

networks:
  app-net:
    driver: bridge
  back-net:
    driver: bridge

volumes:
  proxy:
  db-store:

